#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "control.h"
#include "queue.h"
#include "dbug.h"

int num=4;
char cmd[256];

void *threadfunc(void *arg);
struct work_queue{
	data_control control;
	queue work;
}wq;

typedef struct work_node{
	struct node *next;
	int jobnum;
}wnode;

struct cleanup_queue{
	data_control control;
	queue cleanup;
}cq;

typedef struct cleanup_node{
	struct node *next;
	int threadnum;
	pthread_t tid;
}cnode;

void *threadfunc(void *arg){
	wnode *mywork;
	cnode *mynode;
	int ret,fd;

	mynode=(cnode *)arg;

	pthread_mutex_lock(&wq.control.mutex);
	while(wq.control.active){
		while(wq.work.head == NULL && wq.control.active){
			pthread_cond_wait(&wq.control.cond,&wq.control.mutex);
		}

		if(!wq.control.active)
			break;
		mywork=(wnode *)queue_get(&wq.work);
		pthread_mutex_unlock(&wq.control.mutex);
		printf("Thread number %d processing job %d\n",mynode->threadnum,mywork->jobnum);
		free(mywork);
		pthread_mutex_lock(&wq.control.mutex);
	}
	pthread_mutex_unlock(&wq.control.mutex);


	//zhuyfa, 2004-03-09
#if 0
	fd=open("/pvfs/test",O_RDWR);
	if(fd<0)
		printf("Thread %d open file failed.\n",mynode->threadnum);
	ret=close(fd);

	if(ret<0)
		printf("Thread %d close file failed.\n",mynode->threadnum);
#endif
	
	//sleep(10);
	//ret=execlp(cmd,NULL);
	ret=system(cmd);
	if(ret<0){
		//printf("Thread %d execlp failed.\n",mynode->threadnum);
		perror("Thread execlp failed");
		goto quit;
	}
	//printf("Thread %d execlp success.\n",mynode->threadnum);
quit:
	pthread_mutex_lock(&cq.control.mutex);
	queue_put(&cq.cleanup,(node *)mynode);
	pthread_mutex_unlock(&cq.control.mutex);
	pthread_cond_signal(&cq.control.cond);
	//printf("Thread %d shutting down ...\n",mynode->threadnum);
	return NULL;
}


void join_threads(void){
	cnode *curnode;
	printf("joining threads...\n");

	while(num){
		pthread_mutex_lock(&cq.control.mutex);
		while(cq.cleanup.head == NULL){
			pthread_cond_wait(&cq.control.cond,&cq.control.mutex);
		}
		curnode=(cnode *)queue_get(&cq.cleanup);
		pthread_mutex_unlock(&cq.control.mutex);

		pthread_join(curnode->tid,NULL);
		//printf("joined with thread %d\n",curnode->threadnum);
		free(curnode);
		num--;
	}
}

int create_threads(void){
	int x;
	cnode *curnode;
	pthread_t tid;

	for(x=0;x<num;x++){
		curnode=malloc(sizeof(cnode));
		if(!curnode)
			return 1;
		curnode->threadnum=x;
		if(pthread_create(&curnode->tid,NULL,threadfunc,(void *)curnode))
		//if(pthread_create(&tid,NULL,threadfunc,NULL))
			return 1;
		printf("created thread %d\n",x);
		//num++;
	}
	return 0;
	//return 1;
}

void initialize_structs(void){
	if(control_init(&wq.control))
		dabort();
	queue_init(&wq.work);
	if(control_init(&cq.control)){
		control_destroy(&wq.control);
		dabort();
	}
	queue_init(&cq.cleanup);
	control_activate(&wq.control);
}

void cleanup_structs(void){
	control_destroy(&cq.control);
	control_destroy(&wq.control);
}


int main(int argc,char **argv){
	int x;
	wnode *mywork;
	int opt;

	while((opt = getopt(argc,argv,"n:c:"))!= EOF)
	{
		switch(opt){
			case 'n': num=atoi(optarg);
				  break;
			case 'c': strcpy(cmd,optarg);
				  break;
			default:  break;
		}
	}

	//return 0;

	initialize_structs();
	/*
	if(fork()) 
		exit(0);
	*/
	//sleep(20);

	if(create_threads()){
		printf("Error starting threads... cleaning up.\n");
		join_threads();
		dabort();
	}
	
	pthread_mutex_lock(&wq.control.mutex);
	for(x=0;x<0;x++){
		mywork=malloc(sizeof(wnode));
		if(!mywork){
			printf("ouch,can't malloc work.\n");
			break;
		}
		mywork->jobnum=x;
		queue_put(&wq.work,(node *)mywork);
	}
	pthread_mutex_unlock(&wq.control.mutex);
	pthread_cond_broadcast(&wq.control.cond);

	//printf("sleeping...\n");
	//sleep(2);
	printf("deactivateing work queue...\n");
	control_deactivate(&wq.control);

	join_threads();
	cleanup_structs();
}
